import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.Group;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.image.Image;

/**
 * Mouse input demo
 * 
 * From online tutorial:
 * http://gamedevelopment.tutsplus.com/tutorials/introduction-to-javafx-for-game
 * -development--cms-23835
 * 
 * @author Lee Stemkoski
 * modified by mike slattery - jan 2016
 *
 */
public class Target extends Application {
	Image bullseye;
	Circle targetData = new Circle(100, 100, 32);
	int points = 0;

	public static void main(String[] args) {
		launch(args);
	}

	@Override
	public void start(Stage theStage) {
		theStage.setTitle("Click the Target!");

		Group root = new Group();
		Scene theScene = new Scene(root);
		theStage.setScene(theScene);

		Canvas canvas = new Canvas(500, 500);
		root.getChildren().add(canvas);

		GraphicsContext gc = canvas.getGraphicsContext2D();
		Font theFont = Font.font("Helvetica", FontWeight.BOLD, 24);
		gc.setFont(theFont);
		gc.setStroke(Color.BLACK);
		gc.setLineWidth(1);

		bullseye = new Image("bullseye.png");
		render(gc); //initial render
		
		theScene.setOnMouseClicked(
		e -> {
				if (targetData.containsPoint(e.getX(), e.getY())) {
					double x = 50 + 400 * Math.random();
					double y = 50 + 400 * Math.random();
					targetData.setCenter(x, y);
					points++;
				} else
					points = 0;
				render(gc);
			}
		);

		theStage.show();
	}

	public void render(GraphicsContext gc) {
		// Clear the canvas
		gc.setFill(new Color(0.85, 0.85, 1.0, 1.0));
		gc.fillRect(0, 0, 512, 512);

		gc.drawImage(bullseye, targetData.getX() - targetData.getRadius(), targetData.getY() - targetData.getRadius());

		gc.setFill(Color.BLUE);
		gc.setStroke(Color.LIME);

		String pointsText = "Points: " + points;
		gc.fillText(pointsText, 360, 36);
		gc.strokeText(pointsText, 360, 36);
	}
}